=== modified file 'NEWS'
--- NEWS	2009-03-04 21:02:14 +0000
+++ NEWS	2009-03-01 20:21:01 +0000
@@ -3,53 +3,21 @@
 
 dev [future]
 ---------------
-
-    - Loggerhead now serves bzr branches over HTTP and exposes the URL
-      to branch them. (Jonathan Lange)
-
-    - Leading blank lines in commit messages no longer result in an
-      empty summary. (Colin Watson)
-
-    - Added syntax highlighting to annotate view using
-      python-pygments.  Partially addresses bug #306631. (Peter Bui)
-
-    - Convert newlines in commit messages to HTML line breaks for
-      annotate and changelog views.  Addresses bug #273688. (Peter
-      Bui)
-
-    - serve-branches now errors if run behind a proxy without
-      paste.deploy installed.
-
-    - Loggerhead should now handle file and directory names that need
-      URL escaping without crashing.
-
-    - The start-loggerhead script properly sets the wsgi.url_scheme
-      from the server.webpath option. (neror)
-
-    - The revision page defaults to unified style again, and can
-      convert to a side-by-side view using Javascript.
-
-    - Leading blank lines in commit messages no longer result in an
-      empty summary. (Colin Watson)
-
-    - The user-confusing "next" and "previous" links now read "older"
-      and "newer" respectively.
-
-    - The annotate view now contains line number anchors.
-
-    - The annotate view does syntax highlighting using the "pygments"
-      library.  (Peter Bui)
-
-    - Changelog messages are now displayed with newlines preserved.
-      (Peter Bui)
+    - Loggerhead now serves bzr branches over HTTP and exposes the URL to
+      branch them. (Jonathan Lange)
+
+    - Leading blank lines in commit messages no longer result in an empty
+      summary. (Colin Watson)
+
+    - Added syntax highlighting to annotate view using python-pygments.
+      Partially addresses bug #306631. (Peter Bui)
 
 1.10 [22Dec2008]
 ---------------
-
     - Add startup deamon script for Linux (Marius Kruger)
 
-    - Switch navigation from file_ids to paths. Fixes bugs #260363,
-      #269365 and #128926. (Martin Albisetti)
+    - Switch navigation from file_ids to paths. Fixes bugs #260363, #269365
+      and #128926. (Martin Albisetti)
 
     - Fix bug #258710 ("the /files page explodes in an empty branch").
       Also minor improvements to the /files and /changes pages.

=== modified file 'README.txt'
--- README.txt	2009-03-10 01:05:08 +0000
+++ README.txt	2009-02-24 21:13:30 +0000
@@ -47,15 +47,6 @@
    b) on Sysvinit based systems like Centos or SuSE run:
       chkconfig --add loggerheadd
 
-
-LOGGERHEAD AS A BAZAAR PLUGIN
------------------------------
-
-This branch contains experimental support for using Loggerhead as a Bazaar
-plugin.  To use it, place the top-level Loggerhead directory (the one
-containing this file) at ``~/.bazaar/plugins/loggerhead``.
-
-
 USING A CONFIG FILE
 -------------------
 

=== removed file '__init__.py'
--- __init__.py	2009-03-10 01:01:04 +0000
+++ __init__.py	1970-01-01 00:00:00 +0000
@@ -1,88 +0,0 @@
-# Copyright 2009 Canonical Ltd
-#
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-#
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-#
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-
-
-# This file allows loggerhead to be treated as a plugin for bzr.
-#
-# XXX: Because loggerhead already contains a loggerhead directory, much of the
-# code is going to appear loaded at bzrlib.plugins.loggerhead.loggerhead.
-# This seems like the easiest thing, because bzrlib wants the top-level plugin
-# directory to be the module, but when it's used as a library people expect
-# the source directory to contain a directory called loggerhead.  -- mbp
-# 20090123
-
-"""Loggerhead web viewer for Bazaar branches.
-
-This provides a new option "--http" to the "bzr serve" command, that 
-starts a web server to browse the contents of a branch.
-"""
-
-version_info = (1, 11, 0)
-
-if __name__ == 'bzrlib.plugins.loggerhead':
-    import bzrlib
-    from bzrlib.api import require_any_api
-
-    require_any_api(bzrlib, [(1, 11, 0), (1, 13, 0)])
-
-    # TODO: This should provide a new type of server that can be used by bzr
-    # serve, maybe through a registry, rather than overriding the command.  Though
-    # maybe we should keep the wrapper to work with older bzr releases, at least
-    # for a bit.
-
-    # NB: Normally plugins should lazily load almost everything, but this
-    # seems reasonable to have in-line here: bzrlib.commands and options are
-    # normally loaded, and the rest of loggerhead won't be loaded until serve
-    # --http is run.
-        
-    import bzrlib.builtins
-    from bzrlib.commands import get_cmd_object, register_command
-    from bzrlib.option import Option
-
-    _original_command = get_cmd_object('serve')
-
-    DEFAULT_PORT = 8080
-
-    class cmd_serve(bzrlib.builtins.cmd_serve):
-        __doc__ = _original_command.__doc__
-
-        takes_options = _original_command.takes_options + [
-            Option('http',
-                help='Run an http (Loggerhead) server to browse code, '
-                    'by default on port %s.' % DEFAULT_PORT)]
-
-        def run(self, *args, **kw):
-            if 'http' in kw:
-                # loggerhead internal code will try to 'import loggerhead', so
-                # let's put it on the path
-                import os.path, sys
-                sys.path.append(os.path.dirname(__file__))
-
-                from loggerhead.apps.filesystem import BranchesFromFileSystemRoot
-                from paste.httpexceptions import HTTPExceptionHandler
-                from paste.httpserver import serve
-                a = HTTPExceptionHandler(BranchesFromFileSystemRoot('.'))
-                port = kw.get('port', DEFAULT_PORT)
-                # port might be an int already...
-                if isinstance(port, basestring) and ':' in port:
-                    host, port = port.split(':')
-                else:
-                    host = '0.0.0.0'
-                serve(a, host=host, port=port)
-            else:
-                super(cmd_serve, self).run(*args, **kw)
-
-    register_command(cmd_serve)

=== modified file 'loggerhead/apps/branch.py'
--- loggerhead/apps/branch.py	2009-03-17 00:02:21 +0000
+++ loggerhead/apps/branch.py	2009-02-18 10:36:48 +0000
@@ -11,16 +11,14 @@
 from paste import httpexceptions
 
 from loggerhead.apps import static_app
+from loggerhead.controllers.changelog_ui import ChangeLogUI
+from loggerhead.controllers.inventory_ui import InventoryUI
 from loggerhead.controllers.annotate_ui import AnnotateUI
+from loggerhead.controllers.revision_ui import RevisionUI
 from loggerhead.controllers.atom_ui import AtomUI
-from loggerhead.controllers.changelog_ui import ChangeLogUI
-from loggerhead.controllers.diff_ui import DiffUI
 from loggerhead.controllers.download_ui import DownloadUI
-from loggerhead.controllers.filediff_ui import FileDiffUI
-from loggerhead.controllers.inventory_ui import InventoryUI
-from loggerhead.controllers.revision_ui import RevisionUI
-from loggerhead.controllers.revlog_ui import RevLogUI
 from loggerhead.controllers.search_ui import SearchUI
+from loggerhead.controllers.diff_ui import DiffUI
 from loggerhead.history import History
 from loggerhead import util
 
@@ -80,16 +78,14 @@
         return self._static_url_base + path
 
     controllers_dict = {
-        '+filediff': FileDiffUI,
-        '+revlog': RevLogUI,
         'annotate': AnnotateUI,
-        'atom': AtomUI,
         'changes': ChangeLogUI,
-        'diff': DiffUI,
-        'download': DownloadUI,
         'files': InventoryUI,
         'revision': RevisionUI,
+        'download': DownloadUI,
+        'atom': AtomUI,
         'search': SearchUI,
+        'diff': DiffUI,
         }
 
     def last_updated(self):

=== modified file 'loggerhead/controllers/annotate_ui.py'
--- loggerhead/controllers/annotate_ui.py	2009-03-06 20:36:09 +0000
+++ loggerhead/controllers/annotate_ui.py	2009-03-02 06:10:32 +0000
@@ -58,7 +58,6 @@
         else:
             if highlight is not None:
                 hl_lines = highlight(file_name, ''.join(file_lines))
-                hl_lines.extend([u''] * (len(file_lines) - len(hl_lines)))
             else:
                 hl_lines = file_lines
 

=== modified file 'loggerhead/controllers/changelog_ui.py'
--- loggerhead/controllers/changelog_ui.py	2009-03-16 23:01:40 +0000
+++ loggerhead/controllers/changelog_ui.py	2008-12-05 18:52:44 +0000
@@ -17,9 +17,6 @@
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 #
 
-import simplejson
-import urllib
-
 from paste.httpexceptions import HTTPServerError
 
 from loggerhead import util
@@ -61,10 +58,7 @@
                 scan_list = revid_list[i:]
             change_list = scan_list[:pagesize]
             changes = list(history.get_changes(change_list))
-            data = {}
-            for i, c in enumerate(changes):
-                c.index = i
-                data[str(i)] = urllib.quote(urllib.quote(c.revid, safe=''))
+            history.add_changes(changes)
         except:
             self.log.exception('Exception fetching changes')
             raise HTTPServerError('Could not fetch changes')
@@ -77,6 +71,9 @@
             navigation.query = query
         util.fill_in_navigation(navigation)
 
+        # add parent & merge-point branch-nick info, in case it's useful
+        history.get_branch_nicks(changes)
+
         # Directory Breadcrumbs
         directory_breadcrumbs = (
             util.directory_breadcrumbs(
@@ -87,7 +84,6 @@
         return {
             'branch': self._branch,
             'changes': changes,
-            'data': simplejson.dumps(data),
             'util': util,
             'history': history,
             'revid': revid,

=== removed file 'loggerhead/controllers/filediff_ui.py'
--- loggerhead/controllers/filediff_ui.py	2009-03-17 01:50:50 +0000
+++ loggerhead/controllers/filediff_ui.py	1970-01-01 00:00:00 +0000
@@ -1,97 +0,0 @@
-from StringIO import StringIO
-import urllib
-
-from bzrlib import diff
-from bzrlib import errors
-
-from loggerhead import util
-from loggerhead.controllers import TemplatedBranchView
-
-def _process_diff(difftext):
-    # doesn't really need to be a method; could be static.
-    chunks = []
-    chunk = None
-    for line in difftext.splitlines():
-        if len(line) == 0:
-            continue
-        if line.startswith('+++ ') or line.startswith('--- '):
-            continue
-        if line.startswith('@@ '):
-            # new chunk
-            if chunk is not None:
-                chunks.append(chunk)
-            chunk = util.Container()
-            chunk.diff = []
-            split_lines = line.split(' ')[1:3]
-            lines = [int(x.split(',')[0][1:]) for x in split_lines]
-            old_lineno = lines[0]
-            new_lineno = lines[1]
-        elif line.startswith(' '):
-            chunk.diff.append(util.Container(old_lineno=old_lineno,
-                                             new_lineno=new_lineno,
-                                             type='context',
-                                             line=line[1:]))
-            old_lineno += 1
-            new_lineno += 1
-        elif line.startswith('+'):
-            chunk.diff.append(util.Container(old_lineno=None,
-                                             new_lineno=new_lineno,
-                                             type='insert', line=line[1:]))
-            new_lineno += 1
-        elif line.startswith('-'):
-            chunk.diff.append(util.Container(old_lineno=old_lineno,
-                                             new_lineno=None,
-                                             type='delete', line=line[1:]))
-            old_lineno += 1
-        else:
-            chunk.diff.append(util.Container(old_lineno=None,
-                                             new_lineno=None,
-                                             type='unknown',
-                                             line=repr(line)))
-    if chunk is not None:
-        chunks.append(chunk)
-    return chunks
-
-
-def diff_chunks_for_file(repository, file_id, new_revid, old_revid):
-    old_tree, new_tree = repository.revision_trees([old_revid, new_revid])
-    try:
-        old_lines = old_tree.get_file_lines(file_id)
-    except errors.NoSuchId:
-        old_lines = []
-    try:
-        new_lines = new_tree.get_file_lines(file_id)
-    except errors.NoSuchId:
-        new_lines = []
-    buffer = StringIO()
-    if old_lines != new_lines:
-        try:
-            diff.internal_diff('', old_lines, '', new_lines, buffer)
-        except errors.BinaryFile:
-            difftext = ''
-        else:
-            difftext = buffer.getvalue()
-    else:
-        difftext = ''
-
-    return _process_diff(difftext)
-
-
-class FileDiffUI(TemplatedBranchView):
-
-    template_path = 'loggerhead.templates.filediff'
-
-    def get_values(self, path, kwargs, headers):
-        history = self._history
-
-        revid = urllib.unquote(self.args[0])
-        compare_revid = urllib.unquote(self.args[1])
-        file_id = urllib.unquote(self.args[2])
-
-        chunks = diff_chunks_for_file(
-            self._history._branch.repository, file_id, revid, compare_revid)
-
-        return {
-            'util': util,
-            'chunks': chunks,
-        }

=== modified file 'loggerhead/controllers/inventory_ui.py'
--- loggerhead/controllers/inventory_ui.py	2009-03-03 20:43:12 +0000
+++ loggerhead/controllers/inventory_ui.py	2009-03-01 17:46:31 +0000
@@ -74,7 +74,7 @@
             if path == '':
                 absolutepath = pathname
             else:
-                absolutepath = path + '/' + pathname
+                absolutepath = urllib.quote(path + '/' + pathname)
             revid = entry.revision
 
             file = util.Container(

=== modified file 'loggerhead/controllers/revision_ui.py'
--- loggerhead/controllers/revision_ui.py	2009-03-17 02:19:20 +0000
+++ loggerhead/controllers/revision_ui.py	2009-02-18 01:00:02 +0000
@@ -20,7 +20,6 @@
 from StringIO import StringIO
 
 import bzrlib.diff
-from bzrlib import errors
 
 from paste.httpexceptions import HTTPServerError
 
@@ -81,7 +80,7 @@
             chunks.append(chunk)
         return chunks
 
-    def _parse_diffs(self, old_tree, new_tree, delta, specific_path):
+    def _parse_diffs(self, old_tree, new_tree, delta):
         """
         Return a list of processed diffs, in the format::
 
@@ -101,40 +100,16 @@
         process = []
         out = []
 
-        def include_specific_path(path):
-            return specific_path == path
-        def include_all_paths(path):
-            return True
-        if specific_path:
-            include_path = include_specific_path
-        else:
-            include_path = include_all_paths
-
         for old_path, new_path, fid, \
             kind, text_modified, meta_modified in delta.renamed:
-            if text_modified and include_path(new_path):
+            if text_modified:
                 process.append((old_path, new_path, fid, kind))
         for path, fid, kind, text_modified, meta_modified in delta.modified:
-            if include_path(path):
-                process.append((path, path, fid, kind))
-        for path, fid, kind in delta.added:
-            if kind == 'file' and include_path(path):
-                process.append((path, path, fid, kind))
-        for path, fid, kind in delta.removed:
-            if kind == 'file' and include_path(path):
-                process.append((path, path, fid, kind))
-
-        process.sort(key=lambda x:x[1])
+            process.append((path, path, fid, kind))
 
         for old_path, new_path, fid, kind in process:
-            try:
-                old_lines = old_tree.get_file_lines(fid)
-            except errors.NoSuchId:
-                old_lines = []
-            try:
-                new_lines = new_tree.get_file_lines(fid)
-            except errors.NoSuchId:
-                new_lines = []
+            old_lines = old_tree.get_file_lines(fid)
+            new_lines = new_tree.get_file_lines(fid)
             buffer = StringIO()
             if old_lines != new_lines:
                 try:
@@ -147,13 +122,17 @@
             else:
                 diff = ''
             out.append(util.Container(
-                filename=rich_filename(new_path, kind), file_id=fid,
-                chunks=self._process_diff(diff)))
+                          filename=rich_filename(new_path, kind),
+                          file_id=fid,
+                          chunks=self._process_diff(diff),
+                          raw_diff=diff))
 
         return out
 
-    def get_changes_with_diff(self, change, compare_revid, specific_path):
+    def get_change_with_diff(self, revid, compare_revid):
         h = self._history
+        change = h.get_changes([revid])[0]
+
         if compare_revid is None:
             if change.parents:
                 compare_revid = change.parents[0].revid
@@ -161,13 +140,15 @@
                 compare_revid = 'null:'
 
         rev_tree1 = h._branch.repository.revision_tree(compare_revid)
-        rev_tree2 = h._branch.repository.revision_tree(change.revid)
+        rev_tree2 = h._branch.repository.revision_tree(revid)
         delta = rev_tree2.changes_from(rev_tree1)
 
-        changes = h.parse_delta(delta)
+        change.changes = h.parse_delta(delta)
+        change.changes.modified = self._parse_diffs(rev_tree1,
+                                                    rev_tree2,
+                                                    delta)
 
-        return changes, self._parse_diffs(
-            rev_tree1, rev_tree2, delta, specific_path)
+        return change
 
     def get_values(self, path, kwargs, headers):
         h = self._history
@@ -196,13 +177,16 @@
             navigation.query = query
         util.fill_in_navigation(navigation)
 
-        change = h.get_changes([revid])[0]
-        if path in ('', '/'):
-            path = None
-        change.changes, diffs = self.get_changes_with_diff(change, compare_revid, path)
+        change = self.get_change_with_diff(revid, compare_revid)
         # add parent & merge-point branch-nick info, in case it's useful
         h.get_branch_nicks([change])
 
+        line_count_limit = DEFAULT_LINE_COUNT_LIMIT
+        line_count = 0
+        for file in change.changes.modified:
+            for chunk in file.chunks:
+                line_count += len(chunk.diff)
+
         # Directory Breadcrumbs
         directory_breadcrumbs = (
             util.directory_breadcrumbs(
@@ -214,8 +198,6 @@
             'branch': self._branch,
             'revid': revid,
             'change': change,
-            'diffs': diffs,
-            'specific_path': path,
             'start_revid': start_revid,
             'filter_file_id': filter_file_id,
             'util': util,
@@ -225,5 +207,8 @@
             'remember': remember,
             'compare_revid': compare_revid,
             'url': self._branch.context_url,
+            'line_count': line_count,
+            'line_count_limit': line_count_limit,
+            'show_plain_diffs': line_count > line_count_limit,
             'directory_breadcrumbs': directory_breadcrumbs,
         }

=== removed file 'loggerhead/controllers/revlog_ui.py'
--- loggerhead/controllers/revlog_ui.py	2009-03-16 23:01:40 +0000
+++ loggerhead/controllers/revlog_ui.py	1970-01-01 00:00:00 +0000
@@ -1,26 +0,0 @@
-import urllib
-
-from loggerhead import util
-from loggerhead.controllers import TemplatedBranchView
-
-
-class RevLogUI(TemplatedBranchView):
-
-    template_path = 'loggerhead.templates.revlog'
-
-    def get_values(self, path, kwargs, headers):
-        history = self._history
-
-        revid = urllib.unquote(self.args[0])
-
-        changes = list(history.get_changes([revid]))
-        history.add_changes(changes)
-        history.get_branch_nicks(changes)
-
-        return {
-            'branch': self._branch,
-            'entry': changes[0],
-            'util': util,
-            'revid': revid,
-            'url': self._branch.context_url,
-        }

=== modified file 'loggerhead/highlight.py'
--- loggerhead/highlight.py	2009-03-06 13:19:38 +0000
+++ loggerhead/highlight.py	2009-03-02 00:42:46 +0000
@@ -39,10 +39,10 @@
         text = text.decode(encoding)
 
     try:
-        lexer = guess_lexer_for_filename(path, text[:1024], encoding=encoding)
+        lexer = guess_lexer_for_filename(path, text, encoding=encoding)
     except (ClassNotFound, ValueError):
         try:
-            lexer = guess_lexer(text[:1024], encoding=encoding)
+            lexer = guess_lexer(text, encoding=encoding)
         except (ClassNotFound, ValueError):
             lexer = TextLexer(encoding=encoding)
 

=== modified file 'loggerhead/history.py'
--- loggerhead/history.py	2009-03-06 20:43:13 +0000
+++ loggerhead/history.py	2009-02-26 18:10:29 +0000
@@ -621,23 +621,22 @@
         removed = []
 
         for path, fid, kind in delta.added:
-            added.append(util.Container(
-                filename=rich_filename(path, kind), file_id=fid, kind=kind))
+            added.append((rich_filename(path, kind), fid))
 
         for path, fid, kind, text_modified, meta_modified in delta.modified:
-            modified.append(util.Container(
-                filename=rich_filename(path, kind), file_id=fid))
+            modified.append(util.Container(filename=rich_filename(path, kind),
+                                           file_id=fid))
 
         for old_path, new_path, fid, kind, text_modified, meta_modified in \
-                delta.renamed:
-            renamed.append(util.Container(
-                old_filename=rich_filename(old_path, kind),
-                new_filename=rich_filename(new_path, kind), file_id=fid,
-                text_modified=text_modified))
+delta.renamed:
+            renamed.append((rich_filename(old_path, kind),
+                            rich_filename(new_path, kind), fid))
+            if meta_modified or text_modified:
+                modified.append(util.Container(
+                    filename=rich_filename(new_path, kind), file_id=fid))
 
         for path, fid, kind in delta.removed:
-            removed.append(util.Container(
-                filename=rich_filename(path, kind), file_id=fid, kind=kind))
+            removed.append((rich_filename(path, kind), fid))
 
         return util.Container(added=added, renamed=renamed,
                               removed=removed, modified=modified)

=== modified file 'loggerhead/static/css/global.css'
--- loggerhead/static/css/global.css	2009-03-05 22:56:59 +0000
+++ loggerhead/static/css/global.css	2009-03-02 01:32:36 +0000
@@ -11,9 +11,6 @@
 	font-weight:normal;
 	outline:none;
 }
-b a:link, b a:visited {
-    font-weight: bold;
-}
 img {
 	padding:0px;
 	margin:0px;

=== removed file 'loggerhead/static/images/spinner.gif'
Binary files loggerhead/static/images/spinner.gif and loggerhead/static/images/spinner.gif differ
=== modified file 'loggerhead/static/javascript/changelog.js'
--- loggerhead/static/javascript/changelog.js	2009-03-16 02:58:10 +0000
+++ loggerhead/static/javascript/changelog.js	2009-02-20 03:30:31 +0000
@@ -53,24 +53,15 @@
     revlogs.each(
       function(item, i)
       {
-        var revid = revids[item.get('id').replace('log-', '')];
-        var collapsable = new Collapsable(
-          {
-            expand_icon: item.query('.expand_icon'),
-            open_node: item.query('.long_description'),
-            close_node: item.query('.short_description'),
-            source: global_path + '+revlog/' + revid,
-            source_target: item.query('.source_target'),
-            loading: item.query('.loading'),
-            is_open: false
-          });
+        var item_slide = item.query('.revisioninfo');
+        var open_content  = new Array();
+        var close_content = new Array();
+        open_content.push(item.query('.long_description'));
+        close_content.push(item.query('.short_description'));
+        var expand_icon = item.query('.expand_icon');
+        var collapsable = new Collapsable(item_slide, expand_icon, open_content, close_content, false);
 
-        item.query('.expand_revisioninfo a').on(
-          'click',
-          function(e) {
-            e.preventDefault();
-            collapsable.toggle();
-          });
+        item.query('.expand_revisioninfo').on('click',function(){collapsable.toggle();});
         item.collapsable = collapsable;
       });
 

=== modified file 'loggerhead/static/javascript/custom.js'
--- loggerhead/static/javascript/custom.js	2009-03-16 03:22:02 +0000
+++ loggerhead/static/javascript/custom.js	2009-02-26 01:04:18 +0000
@@ -1,6 +1,4 @@
-Y = YUI().use("node", "io-base", "io-queue", "anim");
-
-Y.io.queue.size(2);
+Y = YUI().use("node", "io-base", "anim");
 
 var global_timeout_id = null;
 var global_search_request = null;
@@ -77,15 +75,30 @@
   setTimeout("Y.get('#search_terms').setStyle('display','none')", 300);
 }
 
-function Collapsable(config)
+function Collapsable(item, expand_icon, open_content, close_content, is_open)
 {
-  this.is_open = config.is_open;
-  this.source_target = config.source_target;
-  this.open_node = config.open_node;
-  this.close_node = config.close_node;
-  this.expand_icon = config.expand_icon;
-  this.source = config.source;
-  this.loading = config.loading;
+  this.is_open = is_open;
+  this.item = item;
+  this.open_content  = open_content;
+  this.close_content = close_content;
+  this.expand_icon   = expand_icon;
+
+  if (this.is_open) {
+    this.height = item.get('region').height;
+  }
+  else {
+    this.height = null;
+  }
+
+  //var expander = new Fx.Slide(this.item, { duration: 200 } );
+  if (!this.is_open)
+  {
+    this.expand_icon.set('src',this.expand_icon.get('title'));
+  }
+  else
+  {
+    this.expand_icon.set('src',this.expand_icon.get('alt'));
+  }
 }
 
 function get_height(node) {
@@ -99,90 +112,56 @@
   return height;
 }
 
-Collapsable.prototype._load_finished = function(tid, res)
-{
-  var newNode = Y.Node.create(res.responseText.split('\n').splice(1).join(''));
-  this.source_target.ancestor().replaceChild(newNode, this.source_target);
-  this.source_target = null;
-  this.source = null;
-  this.loading.setStyle('display', 'none');
-  this.open();
-};
-
 Collapsable.prototype.open = function()
 {
-  if (this.source) {
-    this.loading.setStyle('display', 'block');
-    Y.io.queue(
-      this.source,
-      {
-        on: {complete: this._load_finished},
-        context: this
-      });
-    return;
-  }
-
-  var open_height = get_height(this.open_node);
-
-  var close_height;
-  if (this.close_node) {
-    close_height = this.close_node.get('region').height;
-  }
-  else {
-    close_height = 0;
-  }
-
-  var container = this.open_node.ancestor('.container');
+  if (this.height == null) {
+    this.height = get_height(this.item);
+  }
 
   var anim = new Y.Anim(
     {
-      node: container,
+      node: this.item,
       from: {
-        marginBottom: close_height - open_height
+        height: 0
       },
       to: {
-        marginBottom: 0
+        height: this.height
       },
       duration: 0.2
     });
-
   anim.on('end', this.openComplete, this);
-  container.setStyle('marginBottom', close_height - open_height);
-  if (this.close_node) {
-    this.close_node.setStyle('display', 'none');
-  }
-  this.open_node.setStyle('display', 'block');
-  this.expand_icon.set('src', this.expand_icon.get('alt'));
+  this.item.setStyle('height', 0);
+  this.item.setStyle('display', 'block');
   anim.run();
 };
 
 Collapsable.prototype.openComplete = function()
 {
+  for (var i=0;i<this.open_content.length;++i)
+  {
+    this.open_content[i].setStyle('display','block');
+  }
+
+  for (var i=0;i<this.close_content.length;++i)
+  {
+    this.close_content[i].setStyle('display','none');
+  }
+
+  this.expand_icon.set('src',this.expand_icon.get('alt'));
   this.is_open = true;
 };
 
 Collapsable.prototype.close = function()
 {
-  var container = this.open_node.ancestor('.container');
-
-  var open_height = this.open_node.get('region').height;
-
-  var close_height;
-  if (this.close_node) {
-    close_height = get_height(this.close_node);
-  }
-  else {
-    close_height = 0;
-  }
-
+  var item = this.item;
   var anim = new Y.Anim(
     {
-      node: container,
+      node: this.item,
       from: {
-        marginBottom: 0
+        height: this.height
       },
       to: {
-        marginBottom: close_height - open_height
+        height: 0
       },
       duration: 0.2
     });
@@ -191,18 +170,29 @@
 };
 
 Collapsable.prototype.closeComplete = function () {
-  this.open_node.setStyle('display', 'none');
-  if (this.close_node) {
-    this.close_node.setStyle('display', 'block');
-  }
-  this.open_node.ancestor('.container').setStyle('marginBottom', 0);
-  this.expand_icon.set('src', this.expand_icon.get('title'));
+  this.item.setStyle('display', 'none');
+  var i;
+  for (i=0;i<this.open_content.length;++i)
+  {
+    this.open_content[i].setStyle('display','none');
+  }
+
+  for (i=0;i<this.close_content.length;++i)
+  {
+    this.close_content[i].setStyle('display','block');
+  }
+  this.expand_icon.set('src',this.expand_icon.get('title'));
   this.is_open = false;
 };
 
+Collapsable.prototype.isOpen = function()
+{
+  return this.is_open;
+};
+
 Collapsable.prototype.toggle = function()
 {
-  if (this.is_open)
+  if (this.isOpen())
   {
     this.close();
   }

=== modified file 'loggerhead/static/javascript/diff.js'
--- loggerhead/static/javascript/diff.js	2009-03-16 21:53:23 +0000
+++ loggerhead/static/javascript/diff.js	2009-02-26 02:06:31 +0000
@@ -41,6 +41,7 @@
   var removed = [];
   function clear_bufs(before) {
     if (!added.length && !removed.length) return;
+    Y.log('hai');
     var common = Math.min(added.length, removed.length);
     for (var i = 0; i < common; i++) {
       var a = added[i];
@@ -150,16 +151,10 @@
     diffs.each(
       function(item, i)
       {
-        item.query('.expand_diff').on('click', function() { collapsable.toggle(); });
-        var collapsable = new Collapsable(
-          {
-            expand_icon: item.query('.expand_diff'),
-            open_node: item.ancestor().query('.diffinfo'),
-            close_node: null,
-            source: null,
-            source_target: null,
-            is_open: true
-          });
-       item.collapsable=collapsable;
-       });
+        var item_slide = item.next('.diffinfo');
+        var expand_icon = item.query( '.expand_diff' );
+        var collapsable = new Collapsable(item_slide, expand_icon, [], [], true);
+        item.query('.expand_diff').on('click', function(){collapsable.toggle();});
+        item.collapsable=collapsable;
+      });
   });

=== modified file 'loggerhead/templatefunctions.py'
--- loggerhead/templatefunctions.py	2009-03-07 07:29:26 +0000
+++ loggerhead/templatefunctions.py	2009-02-18 10:36:48 +0000
@@ -13,7 +13,6 @@
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 #
-import cgi
 import os
 from loggerhead.zptsupport import zpt
 
@@ -38,31 +37,18 @@
 
 
 @templatefunc
-def file_change_summary(url, entry, link_style='normal', currently_showing=None):
-    if link_style == 'fragment':
-        def file_link(filename):
-            if currently_showing:
-                if filename == currently_showing:
-                    return '<b><a href="#%s">%s</a></b>' % (
-                        cgi.escape(filename), cgi.escape(filename))
-                else:
-                    return revision_link(url, entry.revno, filename)
-            else:
-                return '<a href="#%s">%s</a>' % (
-                    cgi.escape(filename), cgi.escape(filename))
-    else:
-        file_link = lambda filename: revision_link(url, entry.revno, filename)
+def file_change_summary(url, entry, modified_file_link):
     return _pt('revisionfilechanges').expand(
-        url=url, entry=entry, file_link=file_link,
-        currently_showing=currently_showing, **templatefunctions)
+        url=url, entry=entry, modified_file_link=modified_file_link,
+        **templatefunctions)
 
 
 @templatefunc
-def revisioninfo(url, branch, entry, include_file_list=False, currently_showing=None):
+def revisioninfo(url, branch, entry, modified_file_link=None):
     from loggerhead import util
     return _pt('revisioninfo').expand(
         url=url, change=entry, branch=branch, util=util,
-        include_file_list=include_file_list, currently_showing=currently_showing,
+        modified_file_link=modified_file_link,
         **templatefunctions)
 
 
@@ -98,6 +84,20 @@
 
 
 @templatefunc
+def modified_file_link_rev(url, entry, item):
+    return _pt('modified-file-link-rev').expand(
+        url=url, entry=entry, item=item,
+        **templatefunctions)
+
+
+@templatefunc
+def modified_file_link_log(url, entry, item):
+    return _pt('modified-file-link-log').expand(
+        url=url, entry=entry, item=item,
+        **templatefunctions)
+
+
+@templatefunc
 def search_box(branch, navigation):
     return _pt('search-box').expand(branch=branch, navigation=navigation,
         **templatefunctions)
@@ -112,15 +112,3 @@
 def menu(branch, url, fileview_active=False):
     return _pt('menu').expand(branch=branch, url=url,
         fileview_active=fileview_active, **templatefunctions)
-
-
-@templatefunc
-def annotate_link(url, revno, path):
-    return '<a href="%s" title="Annotate %s">%s</a>'%(
-        url(['/annotate', revno, path]), cgi.escape(path), cgi.escape(path))
-
-@templatefunc
-def revision_link(url, revno, path):
-    return '<a href="%s" title="View changes to %s in revision %s">%s</a>'%(
-        url(['/revision', revno, path]), cgi.escape(path), cgi.escape(revno),
-        cgi.escape(path))

=== modified file 'loggerhead/templates/changelog.pt'
--- loggerhead/templates/changelog.pt	2009-03-16 03:05:49 +0000
+++ loggerhead/templates/changelog.pt	2009-02-26 21:01:19 +0000
@@ -7,9 +7,6 @@
       <link rel="alternate" type="application/atom+xml"
             tal:attributes="href python:url(['/atom']);
                             title string:RSS feed for ${branch/friendly_name}" />
-    <script type="text/javascript">
-      var revids = <tal:block content="data" />;
-    </script>
       <script type="text/javascript"
               tal:attributes="src python:branch.static_url('/static/javascript/changelog.js')"></script>
     </metal:block>
@@ -51,10 +48,10 @@
       </p>
 
       <p class="fr revnolink">From Revision <a tal:attributes="href #
-                                                               title python:'Show revision '+history.get_revno(revid)"
+                                                               title python:'Show revision '+history.get_revno(revid)" 
                                                tal:content="python:history.get_revno(revid)"></a>
         <tal:block tal:condition="python:navigation.last_in_page_revid is not None"> to
-          <a tal:attributes="href #
+          <a tal:attributes="href # 
                              title 'Show revision '+history.get_revno(navigation.last_in_page_revid)"
              tal:content="python:history.get_revno(navigation.last_in_page_revid)"></a>
       </tal:block></p>
@@ -66,11 +63,11 @@
           <img tal:attributes="src python:branch.static_url('/static/images/treeExpanded.png')"
                alt="collapse all" /> collapse all</a>
       </p>
-      <!-- Table -->
+      <!-- Table -->        
       <table id="logentries">
         <tr class="logheader">
           <td class="revisionnumber">Rev</td>
-          <td class="expandcell show_if_js">&nbsp;</td>
+          <td class="expandcell">&nbsp;</td>
           <td class="summarycell">Summary</td>
           <td class="authorcell">Author</td>
           <td class="datecell">Date</td>
@@ -79,45 +76,55 @@
         </tr>
         <tal:block tal:repeat="entry changes">
           <a tal:attributes="name string:entry-${entry/revno}"/>
-          <tr tal:attributes="class string:blueRow${entry/parity} revision_log; id string:log-${entry/index}">
+          <tr tal:attributes="class string:blueRow${entry/parity} revision_log">
             <td class="revnro revnolink"><a tal:attributes="title python:'Show revision '+entry.revno;
                                                             href  python:url(['/revision', entry.revno], clear=1)"
                                             tal:content="python:util.trunc(entry.revno)"></a>
-            </td>
-            <td class="expcell show_if_js">
+            </td>            
+            <td class="expcell">
               <div class="expand_revisioninfo">
                 <!-- So, this is interesting. I'm using "alt" to have the correct URL for the image of the expanded icon
                      and "title" tag for the contracted URL of the image. This is a bit of a hack, but it's better than
                      other approaches I tried  :)  -->
-                <a href="#">
-                  <img tal:attributes="src python:branch.static_url('/static/images/treeCollapsed.png');
-                                       alt python:branch.static_url('/static/images/treeExpanded.png');
-                                       title python:branch.static_url('/static/images/treeCollapsed.png')"
-                       class="expand_icon" />
-                </a>
+                <img tal:attributes="src python:branch.static_url('/static/images/treeCollapsed.png');
+                                     alt python:branch.static_url('/static/images/treeExpanded.png');
+                                     title python:branch.static_url('/static/images/treeCollapsed.png')" 
+                     class="expand_icon" />
               </div>
             </td>
-            <td class="summcell">
-              <div style="overflow: hidden">
-                <div class="container">
-                  <div class="short_description">
-                    <a tal:attributes="title python:'Show revision '+entry.revno;
-                                       href  python:url(['/revision', entry.revno], clear=1);
-                                       class string:link"
-                       tal:content="entry/short_comment"></a>
-                    <div class="loading" style="display:none;">
-                      <img tal:attributes="src python:branch.static_url('/static/images/spinner.gif')" />
-                    </div>
-                  </div>
-                  <div class="long_description" style="display: none">
-                    <a tal:attributes="title python:'Show revision '+entry.revno;
-                                       href  python:url(['/revision', entry.revno], clear=1);
-                                       class string:link"
-                       tal:content="structure python:util.fixed_width(entry.comment)"></a>
-                    <div class="source_target">
-                    </div>
-                  </div>
-                </div>
+            <td class="summcell"><div tal:attributes="class string:short_description">
+                <a tal:attributes="title python:'Show revision '+entry.revno;
+                                   href  python:url(['/revision', entry.revno], clear=1);
+                                   class string:link"
+                   tal:content="entry/short_comment"></a>
+              </div>
+              <div tal:attributes="class string:long_description;
+                                   style string:display:none">
+                <a tal:attributes="title python:'Show revision '+entry.revno;
+                                   href  python:url(['/revision', entry.revno], clear=1);
+                                   class string:link"
+                   tal:content="entry/comment"></a>
+              </div>
+              <div class="revisioninfo" style="display:none;">
+                <ul class="expandrev">
+               	  <li class="mfrom" tal:repeat="parent python:entry.parents[1:]">
+                    <span class="revnolink">
+                      <a tal:attributes="href python:url(['/changes', parent.revno])"
+                         tal:content="parent/revno"></a>
+                    </span>
+                    <a tal:condition="parent.branch_nick"
+                       tal:attributes="href python:url(['/changes'], start_revid=parent.revno)"
+                       tal:content="python:'(' + parent.branch_nick + ')'"
+                       title="Show history" class="link"></a>
+                  </li>
+               	  <li class="mto" tal:repeat="merge_point entry/merge_points">
+                    <a tal:attributes="href python:url(['/changes'], start_revid=merge_point.revno)"
+                       tal:content="python:revno_with_nick(merge_point)"
+                       title="Show history" class="link"></a>
+                  </li>
+                  <li class="committerli" tal:content="python:util.hide_email(entry.author)"></li>
+                  <tal:block content="structure python:file_change_summary(url, entry, modified_file_link_log)" />
+                </ul>
               </div>
             </td>
             <td tal:content="python:util.trunc(util.hide_email(entry.author), 20)"
@@ -139,7 +146,7 @@
 
       <ul tal:condition="python:navigation.prev_page_revid or navigation.next_page_revid"
           id="pages">
-        <li tal:condition="navigation/prev_page_revid"
+        <li tal:condition="navigation/prev_page_revid" 
             class="previous">
           <a tal:attributes="href navigation/prev_page_url">&laquo; Newer</a>
         </li>

=== removed file 'loggerhead/templates/filediff.pt'
--- loggerhead/templates/filediff.pt	2009-03-17 00:02:21 +0000
+++ loggerhead/templates/filediff.pt	1970-01-01 00:00:00 +0000
@@ -1,25 +0,0 @@
-<div class="diffinfo">
-  <div class="pseudotable unified"
-       tal:repeat="chunk chunks">
-
-    <tal:block condition="not:repeat/chunk/start">
-      <div class="pseudorow context-row">
-        <div class="lineNumber separate"></div>
-        <div class="lineNumber second separate"></div>
-        <div class="code separate"></div>
-        <div class="clear"><!-- --></div>
-      </div>
-    </tal:block>
-
-    <div tal:repeat="line chunk/diff"
-         tal:attributes="class string:pseudorow ${line/type}-row">
-      <div class="lineNumber first"
-           tal:content="structure python:util.fill_div(line.old_lineno)"></div>
-      <div class="lineNumber second"
-           tal:content="structure python:util.fill_div(line.new_lineno)"></div>
-      <div tal:attributes="class string:code ${line/type}"
-           tal:content="structure python:util.fill_div(util.html_clean(line.line))"></div>
-      <div class="clear"><!-- --></div>
-    </div>
-  </div>
-</div>

=== modified file 'loggerhead/templates/macros.pt'
--- loggerhead/templates/macros.pt	2009-03-16 03:22:02 +0000
+++ loggerhead/templates/macros.pt	2009-03-02 05:09:06 +0000
@@ -42,9 +42,6 @@
             tal:attributes="src
             python:branch.static_url('/static/javascript/yui/build/io/io-base-min.js')"></script>
     <script type="text/javascript"
-            tal:attributes="src
-            python:branch.static_url('/static/javascript/yui/build/io/io-queue-min.js')"></script>
-    <script type="text/javascript"
             tal:attributes="src python:branch.static_url('/static/javascript/custom.js')"></script>
     <metal:block metal:define-slot="header_extras" />
   </head>

=== added file 'loggerhead/templates/modified-file-link-rev.pt'
--- loggerhead/templates/modified-file-link-rev.pt	1970-01-01 00:00:00 +0000
+++ loggerhead/templates/modified-file-link-rev.pt	2008-06-19 21:39:15 +0000
@@ -0,0 +1,7 @@
+<tal:block>
+<li class="files"><a 
+     tal:attributes="href  string:#${item/filename}-s;
+                     title string:Jump to ${item/filename} below"
+     tal:content="item/filename" >
+</a></li>
+</tal:block>

=== modified file 'loggerhead/templates/revision.pt'
--- loggerhead/templates/revision.pt	2009-03-16 06:44:50 +0000
+++ loggerhead/templates/revision.pt	2009-02-26 21:01:19 +0000
@@ -27,31 +27,12 @@
           <tal:no-link condition="not: branch/branch_link">
             <span metal:use-macro="breadcrumbs/directory"></span>
           </tal:no-link>
-          <span class="breadcrumb">:
-            <tal:revno condition="not:specific_path" content="change/revno"></tal:revno>
-            <a tal:condition="specific_path" tal:content="change/revno"
-               tal:attributes="href python:url(['/revision', change.revno])"
-               title="View changes to all files"></a>
-                      <tal:compare-to condition="python:compare_revid is not None">
+          <span>: <tal:revno content="change/revno"></tal:revno>
+            <tal:compare-to condition="python:compare_revid is not None">
               (compared to revision <tal:block content="python:history.get_revno(compare_revid)" />)
             </tal:compare-to>
-          </span>
-          <span class="breadcrumb" tal:condition="specific_path">
-            : <tal:annotate content="structure python:annotate_link(url, change.revno, specific_path)" />
-          </span>
-        </h1>
+        </span></h1>
         <tal:branch-info replace="structure python:branchinfo(branch)" />
-        <p tal:condition="not:specific_path">
-          Viewing all changes in revision <tal:revno content="change/revno" />.
-        </p>
-        <p tal:condition="specific_path">
-          <a tal:attributes="href python:url(['/revision', change.revno])">
-            &#xAB; back to all changes in this revision
-          </a>
-        </p>
-        <p tal:condition="specific_path">
-          Viewing changes to <tal:annotate content="structure python:annotate_link(url, change.revno, specific_path)" />
-        </p>
         <ul id="submenuTabs">
           <li id="first"><a tal:attributes="href python:url(['/files', change.revno]);
                                             title string:browse files at revision ${change/revno}"
@@ -91,7 +72,7 @@
           </ul>
         </tal:we-are-comparing>
 
-        <tal:revision-info replace="structure python:revisioninfo(url, branch, change, 'fragment', specific_path)" />
+        <tal:revision-info replace="structure python:revisioninfo(url, branch, change, modified_file_link_rev)" />
         <p class="expand" id="expand_all" style="display:none;"><a href="#">
             <img tal:attributes="src python:branch.static_url('/static/images/treeCollapsed.png')"
                  alt="expand all" /> expand all</a>
@@ -110,45 +91,41 @@
 
       <div metal:fill-slot="content">
         <div class="diff"
-             tal:repeat="item diffs">
+             tal:repeat="item change/changes/modified">
 
           <div class="diffBox">
             <img tal:attributes="src python:branch.static_url('/static/images/treeExpanded.png');
                                  title python:branch.static_url('/static/images/treeCollapsed.png');
                                  alt python:branch.static_url('/static/images/treeExpanded.png')"
                  class="expand_diff" />
-            <a tal:attributes="href python:url(['/revision', change.revno, item.filename], clear=1);
-                               id string:${item/filename};
-                               title string:View changes to ${item/filename} only"
+            <a tal:attributes="href python:url(['/annotate', change.revno], clear=1, file_id=item.file_id);
+                               id string:${item/filename}-s;
+                               title string:Annotate ${item/filename}"
                tal:content="item/filename">
             </a>
           </div>
-          <div style="overflow: hidden">
-            <div class="container">
-              <div class="diffinfo">
-                <div class="pseudotable unified"
-                     tal:repeat="chunk item/chunks">
-
-                  <tal:block condition="not:repeat/chunk/start">
-                    <div class="pseudorow context-row">
-                      <div class="lineNumber separate"></div>
-                      <div class="lineNumber second separate"></div>
-                      <div class="code separate"></div>
-                      <div class="clear"><!-- --></div>
-                    </div>
-                  </tal:block>
-
-                  <div tal:repeat="line chunk/diff"
-                       tal:attributes="class string:pseudorow ${line/type}-row">
-                    <div class="lineNumber first"
-                         tal:content="structure python:util.fill_div(line.old_lineno)"></div>
-                    <div class="lineNumber second"
-                         tal:content="structure python:util.fill_div(line.new_lineno)"></div>
-                    <div tal:attributes="class string:code ${line/type}"
-                         tal:content="structure python:util.fill_div(util.html_clean(line.line))"></div>
-                    <div class="clear"><!-- --></div>
-                  </div>
+          <div class="diffinfo">
+            <div class="pseudotable unified"
+                 tal:repeat="chunk item/chunks">
+
+              <tal:block condition="not:repeat/chunk/start">
+                <div class="pseudorow context">
+                  <div class="lineNumber separate"></div>
+                  <div class="lineNumber second separate"></div>
+                  <div class="code separate"></div>
+                  <div class="clear"><!-- --></div>
                 </div>
+              </tal:block>
+
+              <div tal:repeat="line chunk/diff"
+                   tal:attributes="class string:pseudorow ${line/type}-row">
+                <div class="lineNumber first"
+                     tal:content="structure python:util.fill_div(line.old_lineno)"></div>
+                <div class="lineNumber second"
+                     tal:content="structure python:util.fill_div(line.new_lineno)"></div>
+                <div tal:attributes="class string:code ${line/type}"
+                     tal:content="structure python:util.fill_div(util.html_clean(line.line))"></div>
+                <div class="clear"><!-- --></div>
               </div>
             </div>
           </div>

=== modified file 'loggerhead/templates/revisionfilechanges.pt'
--- loggerhead/templates/revisionfilechanges.pt	2009-03-05 23:41:51 +0000
+++ loggerhead/templates/revisionfilechanges.pt	2008-07-23 21:31:07 +0000
@@ -1,50 +1,58 @@
 <tal:block>
-  <ul tal:repeat="added entry/changes/added">
+<ul tal:repeat="added entry/changes/added">
     <tal:block condition="repeat/added/start">
-      <li class="desc">files added:</li>
+        <li class="desc">files added:</li>
     </tal:block>
-    <li class="files">
-      <tal:revision condition="python:added.kind == 'file'"
-                    content="structure python:file_link(added.filename)" />
-      <tal:revision condition="python:added.kind != 'file'"
-                    content="added/filename" />
+    <li class="files"
+        tal:define="filename python:added[0];
+                    file_id  python:added[1]">
+        <a tal:attributes="href  python:url(['/annotate', entry.revno], file_id=file_id);
+                           title string:Annotate ${filename}"
+           tal:content="filename" class="link"></a>
     </li>
-  </ul>
+</ul>
 
-  <ul tal:repeat="removed entry/changes/removed">
+<ul tal:repeat="removed entry/changes/removed">
     <tal:block condition="repeat/removed/start">
-      <li class="desc">files removed:</li>
+        <li class="desc">files removed:</li>
     </tal:block>
-    <li class="files">
-      <tal:revision condition="python:removed.kind == 'file'"
-                    content="structure python:file_link(removed.filename)" />
-      <tal:revision condition="python:removed.kind != 'file'"
-                    content="removed/filename" />
+    <li class="files"
+        tal:define="filename python:removed[0];
+                    file_id  python:removed[1]">
+      <tal:block content="filename" />
     </li>
-  </ul>
+</ul>
 
-  <ul tal:repeat="renamed entry/changes/renamed">
+<ul tal:repeat="renamed entry/changes/renamed">
     <tal:block condition="repeat/renamed/start">
-      <li class="desc">files renamed:</li>
+        <li class="desc">files renamed:</li>
     </tal:block>
-    <li class="files">
-      <tal:old-name content="renamed/old_filename" class="filename">
+    <li class="files"
+        tal:define="old_filename python:renamed[0];
+                    new_filename python:renamed[1];
+                    file_id      python:renamed[2]">
+      <a tal:attributes="href  python:url(['/annotate', entry.revno], file_id=file_id);
+                         title string:Annotate ${old_filename}"
+         tal:content="old_filename" class="filename">
         old_filename
-      </tal:old-name>
-      =&gt;
-      <tal:revision condition="renamed/text_modified" content="structure python:file_link(renamed.new_filename)" />
-      <tal:old-name condition="not:renamed/text_modified" content="renamed/new_filename" class="filename">
+      </a>
+      =>
+      <a tal:attributes="href  python:url(['/annotate', entry.revno], file_id=file_id);
+                         title string:Annotate ${new_filename}"
+         tal:content="new_filename">
         new_filename
-      </tal:old-name>
+      </a>
     </li>
-  </ul>
+</ul>
 
-  <ul tal:repeat="item entry/changes/modified">
+<ul tal:repeat="item entry/changes/modified">
     <tal:block condition="repeat/item/start">
-      <li class="desc">files modified:</li>
+        <li class="desc">files modified:</li>
     </tal:block>
     <li class="files">
-      <tal:revision content="structure python:file_link(item.filename)" />
+      <a tal:attributes="href  python:url(['/annotate', entry.revno], file_id=item.file_id);
+                         title string:Annotate ${item/filename}"
+                         tal:content="item/filename"/>
     </li>
-  </ul>
+</ul>
 </tal:block>

=== modified file 'loggerhead/templates/revisioninfo.pt'
--- loggerhead/templates/revisioninfo.pt	2009-03-05 22:56:59 +0000
+++ loggerhead/templates/revisioninfo.pt	2009-01-23 19:19:39 +0000
@@ -13,10 +13,11 @@
                tal:content="python:revno_with_nick(merge_point)"></a>
         </div>
         <div class="revid" tal:content="string:Revision ID: ${change/revid}"></div>
-        <div class="information" tal:content="structure python:util.fixed_width(change.comment)"></div>
+        <div class="information" tal:content="python:util.fixed_width(change.comment)"></div>
     </div>
-    <ul id="list-files" tal:condition="include_file_list">
-      <tal:block content="structure python:file_change_summary(url, change, 'fragment', currently_showing)" />
+    <ul id="list-files">
+        <tal:block condition="nocall:modified_file_link">
+        <tal:block content="structure python:file_change_summary(url, change, modified_file_link)" /></tal:block>
     </ul>
     <div class="clear"><!-- --></div>
 </div>

=== removed file 'loggerhead/templates/revlog.pt'
--- loggerhead/templates/revlog.pt	2009-03-13 05:36:26 +0000
+++ loggerhead/templates/revlog.pt	1970-01-01 00:00:00 +0000
@@ -1,21 +0,0 @@
-<div class="revisioninfo">
-  <ul class="expandrev">
-    <li class="mfrom" tal:repeat="parent python:entry.parents[1:]">
-      <span class="revnolink">
-        <a tal:attributes="href python:url(['/changes', parent.revno])"
-           tal:content="parent/revno"></a>
-      </span>
-      <a tal:condition="parent.branch_nick"
-         tal:attributes="href python:url(['/changes'], start_revid=parent.revno)"
-         tal:content="python:'(' + parent.branch_nick + ')'"
-         title="Show history" class="link"></a>
-    </li>
-    <li class="mto" tal:repeat="merge_point entry/merge_points">
-      <a tal:attributes="href python:url(['/changes'], start_revid=merge_point.revno)"
-         tal:content="python:revno_with_nick(merge_point)"
-         title="Show history" class="link"></a>
-    </li>
-    <li class="committerli" tal:content="python:util.hide_email(entry.author)"></li>
-    <tal:block content="structure python:file_change_summary(url, entry)" />
-  </ul>
-</div>

=== modified file 'loggerhead/tests/test_controllers.py'
--- loggerhead/tests/test_controllers.py	2009-02-26 06:31:24 +0000
+++ loggerhead/tests/test_controllers.py	2009-02-23 20:32:43 +0000
@@ -32,8 +32,8 @@
         self.build_tree_contents(shape1)
         tree.smart_add([])
         tree.commit('')
+        tree.smart_add([])
         self.build_tree_contents(shape2)
-        tree.smart_add([])
         tree.commit('')
         tree.branch.lock_read()
         self.addCleanup(tree.branch.unlock)
@@ -56,22 +56,6 @@
             rev_ui.get_values('2', {}, []),
             dict)
 
-    def test_get_changes_with_diff(self):
-        branch, rev_ui = self.make_bzrbranch_and_revision_ui_for_tree_shapes(
-            [('file', 'oldcontents'), ('file2', 'oldcontents')],
-            [('file', 'newcontents'), ('file2', 'oldcontents')])
-        change = rev_ui._history.get_changes([branch.last_revision()])[0]
-        changes, diffs = rev_ui.get_changes_with_diff(change, None, None)
-        self.assertEqual(1, len(diffs))
-
-    def test_get_changes_with_diff_specific_path(self):
-        branch, rev_ui = self.make_bzrbranch_and_revision_ui_for_tree_shapes(
-            [('file', 'oldcontents'), ('file2', 'oldcontents')],
-            [('file', 'newcontents'), ('file2', 'newcontents')])
-        change = rev_ui._history.get_changes([branch.last_revision()])[0]
-        changes, diffs = rev_ui.get_changes_with_diff(change, None, 'file')
-        self.assertEqual(1, len(diffs))
-
 class TestAnnotateUI(BasicTests):
 
     def make_annotate_ui_for_file_history(self, file_id, rev_ids_texts):

=== modified file 'loggerhead/tests/test_corners.py'
--- loggerhead/tests/test_corners.py	2009-03-16 18:54:39 +0000
+++ loggerhead/tests/test_corners.py	2009-02-10 01:58:31 +0000
@@ -46,7 +46,7 @@
         res = app.get('/changes')
         # It's not much of an assertion, but we only really care about
         # "assert not crashed".
-        res.mustcontain('1')
+        res.mustcontain('myfilename')
 
     def test_whitespace_only_commit_message(self):
         """Check that a whitespace-only commit message does not break the
@@ -61,4 +61,4 @@
         res = app.get('/changes')
         # It's not much of an assertion, but we only really care about
         # "assert not crashed".
-        res.mustcontain('1')
+        res.mustcontain('myfilename')

=== modified file 'loggerhead/util.py'
--- loggerhead/util.py	2009-03-03 21:39:54 +0000
+++ loggerhead/util.py	2009-03-01 20:57:52 +0000
@@ -24,8 +24,6 @@
 except ImportError:
     from elementtree import ElementTree as ET
 
-from simpletal.simpleTALUtils import HTMLStructureCleaner
-
 import base64
 import cgi
 import datetime
@@ -224,7 +222,6 @@
             s = s.decode('iso-8859-15')
         return s
 
-HSC = HTMLStructureCleaner()
 
 def fixed_width(s):
     """
@@ -241,10 +238,7 @@
             s = s.decode('utf-8')
         except UnicodeDecodeError:
             s = s.decode('iso-8859-15')
-
-    s = s.expandtabs().replace(' ', NONBREAKING_SPACE)
-
-    return HSC.clean(s).replace('\n', '<br/>')
+    return s.expandtabs().replace(' ', NONBREAKING_SPACE)
 
 
 def fake_permissions(kind, executable):

